<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/anyhow-1.0.58/src/macros.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>macros.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../anyhow/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../anyhow/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../anyhow/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
</pre><pre class="rust"><code><span class="doccomment">/// Return early with an error.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This macro is equivalent to `return Err(`[`anyhow!($args...)`][anyhow!]`)`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The surrounding function&#39;s or closure&#39;s return value is required to be</span>
<span class="doccomment">/// `Result&lt;_,`[`anyhow::Error`][crate::Error]`&gt;`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [anyhow!]: crate::anyhow</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// # use anyhow::{bail, Result};</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// # fn has_permission(user: usize, resource: usize) -&gt; bool {</span>
<span class="doccomment">/// #     true</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// # fn main() -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">/// #     let user = 0;</span>
<span class="doccomment">/// #     let resource = 0;</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// if !has_permission(user, resource) {</span>
<span class="doccomment">///     bail!(&quot;permission denied for accessing {}&quot;, resource);</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// #     Ok(())</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// # use anyhow::{bail, Result};</span>
<span class="doccomment">/// # use thiserror::Error;</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// # const MAX_DEPTH: usize = 1;</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// #[derive(Error, Debug)]</span>
<span class="doccomment">/// enum ScienceError {</span>
<span class="doccomment">///     #[error(&quot;recursion limit exceeded&quot;)]</span>
<span class="doccomment">///     RecursionLimitExceeded,</span>
<span class="doccomment">///     # #[error(&quot;...&quot;)]</span>
<span class="doccomment">///     # More = (stringify! {</span>
<span class="doccomment">///     ...</span>
<span class="doccomment">///     # }, 1).1,</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # fn main() -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">/// #     let depth = 0;</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// if depth &gt; MAX_DEPTH {</span>
<span class="doccomment">///     bail!(ScienceError::RecursionLimitExceeded);</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// #     Ok(())</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="macro">macro_rules!</span> <span class="ident">bail</span> {
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">msg</span>:<span class="ident">literal</span> $(,)<span class="question-mark">?</span>) =&gt; {
        <span class="kw">return</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::private::Err</span>(<span class="macro-nonterminal">$</span><span class="macro">crate::__anyhow!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">msg</span>))
    };
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">err</span>:<span class="ident">expr</span> $(,)<span class="question-mark">?</span>) =&gt; {
        <span class="kw">return</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::private::Err</span>(<span class="macro-nonterminal">$</span><span class="macro">crate::__anyhow!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">err</span>))
    };
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">fmt</span>:<span class="ident">expr</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) =&gt; {
        <span class="kw">return</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::private::Err</span>(<span class="macro-nonterminal">$</span><span class="macro">crate::__anyhow!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">fmt</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="kw-2">*</span>))
    };
}

<span class="doccomment">/// Return early with an error if a condition is not satisfied.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This macro is equivalent to `if !$cond { return</span>
<span class="doccomment">/// Err(`[`anyhow!($args...)`][anyhow!]`); }`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The surrounding function&#39;s or closure&#39;s return value is required to be</span>
<span class="doccomment">/// `Result&lt;_,`[`anyhow::Error`][crate::Error]`&gt;`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Analogously to `assert!`, `ensure!` takes a condition and exits the function</span>
<span class="doccomment">/// if the condition fails. Unlike `assert!`, `ensure!` returns an `Error`</span>
<span class="doccomment">/// rather than panicking.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [anyhow!]: crate::anyhow</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// # use anyhow::{ensure, Result};</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// # fn main() -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">/// #     let user = 0;</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// ensure!(user == 0, &quot;only user 0 is allowed&quot;);</span>
<span class="doccomment">/// #     Ok(())</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// # use anyhow::{ensure, Result};</span>
<span class="doccomment">/// # use thiserror::Error;</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// # const MAX_DEPTH: usize = 1;</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// #[derive(Error, Debug)]</span>
<span class="doccomment">/// enum ScienceError {</span>
<span class="doccomment">///     #[error(&quot;recursion limit exceeded&quot;)]</span>
<span class="doccomment">///     RecursionLimitExceeded,</span>
<span class="doccomment">///     # #[error(&quot;...&quot;)]</span>
<span class="doccomment">///     # More = (stringify! {</span>
<span class="doccomment">///     ...</span>
<span class="doccomment">///     # }, 1).1,</span>
<span class="doccomment">/// }</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # fn main() -&gt; Result&lt;()&gt; {</span>
<span class="doccomment">/// #     let depth = 0;</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// ensure!(depth &lt;= MAX_DEPTH, ScienceError::RecursionLimitExceeded);</span>
<span class="doccomment">/// #     Ok(())</span>
<span class="doccomment">/// # }</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">doc</span>)]</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="macro">macro_rules!</span> <span class="ident">ensure</span> {
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">cond</span>:<span class="ident">expr</span> $(,)<span class="question-mark">?</span>) =&gt; {
        <span class="kw">if</span> <span class="op">!</span><span class="macro-nonterminal">$</span><span class="macro-nonterminal">cond</span> {
            <span class="kw">return</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::private::Err</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Error::msg</span>(
                <span class="macro-nonterminal">$</span><span class="macro">crate::private::concat!</span>(<span class="string">&quot;Condition failed: `&quot;</span>, <span class="macro-nonterminal">$</span><span class="macro">crate::private::stringify!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">cond</span>), <span class="string">&quot;`&quot;</span>)
            ));
        }
    };
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">cond</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">msg</span>:<span class="ident">literal</span> $(,)<span class="question-mark">?</span>) =&gt; {
        <span class="kw">if</span> <span class="op">!</span><span class="macro-nonterminal">$</span><span class="macro-nonterminal">cond</span> {
            <span class="kw">return</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::private::Err</span>(<span class="macro-nonterminal">$</span><span class="macro">crate::__anyhow!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">msg</span>));
        }
    };
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">cond</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">err</span>:<span class="ident">expr</span> $(,)<span class="question-mark">?</span>) =&gt; {
        <span class="kw">if</span> <span class="op">!</span><span class="macro-nonterminal">$</span><span class="macro-nonterminal">cond</span> {
            <span class="kw">return</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::private::Err</span>(<span class="macro-nonterminal">$</span><span class="macro">crate::__anyhow!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">err</span>));
        }
    };
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">cond</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">fmt</span>:<span class="ident">expr</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) =&gt; {
        <span class="kw">if</span> <span class="op">!</span><span class="macro-nonterminal">$</span><span class="macro-nonterminal">cond</span> {
            <span class="kw">return</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::private::Err</span>(<span class="macro-nonterminal">$</span><span class="macro">crate::__anyhow!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">fmt</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="kw-2">*</span>));
        }
    };
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">doc</span>))]</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="macro">macro_rules!</span> <span class="ident">ensure</span> {
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tt</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) =&gt; {
        <span class="macro-nonterminal">$</span><span class="macro">crate::__parse_ensure!</span>(
            <span class="comment">/* state */</span> <span class="number">0</span>
            <span class="comment">/* stack */</span> ()
            <span class="comment">/* bail */</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tt</span>)<span class="kw-2">*</span>)
            <span class="comment">/* fuel */</span> (~~~~~~~~~~ ~~~~~~~~~~ ~~~~~~~~~~ ~~~~~~~~~~ ~~~~~~~~~~ ~~~~~~~~~~ ~~~~~~~~~~ ~~~~~~~~~~ ~~~~~~~~~~ ~~~~~~~~~~ ~~~~~~~~~~ ~~~~~~~~~~)
            <span class="comment">/* parse */</span> {()}
            <span class="comment">/* dup */</span> ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tt</span>)<span class="kw-2">*</span>)
            <span class="comment">/* rest */</span> $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">tt</span>)<span class="op">*</span>
        )
    };
}

<span class="doccomment">/// Construct an ad-hoc error from a string or existing non-`anyhow` error</span>
<span class="doccomment">/// value.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This evaluates to an [`Error`][crate::Error]. It can take either just a</span>
<span class="doccomment">/// string, or a format string with arguments. It also can take any custom type</span>
<span class="doccomment">/// which implements `Debug` and `Display`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// If called with a single argument whose type implements `std::error::Error`</span>
<span class="doccomment">/// (in addition to `Debug` and `Display`, which are always required), then that</span>
<span class="doccomment">/// Error impl&#39;s `source` is preserved as the `source` of the resulting</span>
<span class="doccomment">/// `anyhow::Error`.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// # type V = ();</span>
<span class="doccomment">/// #</span>
<span class="doccomment">/// use anyhow::{anyhow, Result};</span>
<span class="doccomment">///</span>
<span class="doccomment">/// fn lookup(key: &amp;str) -&gt; Result&lt;V&gt; {</span>
<span class="doccomment">///     if key.len() != 16 {</span>
<span class="doccomment">///         return Err(anyhow!(&quot;key length must be 16 characters, got {:?}&quot;, key));</span>
<span class="doccomment">///     }</span>
<span class="doccomment">///</span>
<span class="doccomment">///     // ...</span>
<span class="doccomment">///     # Ok(())</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="macro">macro_rules!</span> <span class="ident">anyhow</span> {
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">msg</span>:<span class="ident">literal</span> $(,)<span class="question-mark">?</span>) =&gt; {
        <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::private::must_use</span>({
            <span class="kw">let</span> <span class="ident">error</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::private::format_err</span>(<span class="macro-nonterminal">$</span><span class="macro">crate::private::format_args!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">msg</span>));
            <span class="ident">error</span>
        })
    };
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">err</span>:<span class="ident">expr</span> $(,)<span class="question-mark">?</span>) =&gt; {
        <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::private::must_use</span>({
            <span class="kw">use</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::private::kind</span>::<span class="kw-2">*</span>;
            <span class="kw">let</span> <span class="ident">error</span> <span class="op">=</span> <span class="kw">match</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">err</span> {
                <span class="ident">error</span> =&gt; (<span class="kw-2">&amp;</span><span class="ident">error</span>).<span class="ident">anyhow_kind</span>().<span class="ident">new</span>(<span class="ident">error</span>),
            };
            <span class="ident">error</span>
        })
    };
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">fmt</span>:<span class="ident">expr</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) =&gt; {
        <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Error::msg</span>(<span class="macro-nonterminal">$</span><span class="macro">crate::private::format!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">fmt</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="kw-2">*</span>))
    };
}

<span class="comment">// Not public API. This is used in the implementation of some of the other</span>
<span class="comment">// macros, in which the must_use call is not needed because the value is known</span>
<span class="comment">// to be used.</span>
<span class="attribute">#[<span class="ident">doc</span>(<span class="ident">hidden</span>)]</span>
<span class="attribute">#[<span class="ident">macro_export</span>]</span>
<span class="macro">macro_rules!</span> <span class="ident">__anyhow</span> {
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">msg</span>:<span class="ident">literal</span> $(,)<span class="question-mark">?</span>) =&gt; ({
        <span class="kw">let</span> <span class="ident">error</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::private::format_err</span>(<span class="macro-nonterminal">$</span><span class="macro">crate::private::format_args!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">msg</span>));
        <span class="ident">error</span>
    });
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">err</span>:<span class="ident">expr</span> $(,)<span class="question-mark">?</span>) =&gt; ({
        <span class="kw">use</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::private::kind</span>::<span class="kw-2">*</span>;
        <span class="kw">let</span> <span class="ident">error</span> <span class="op">=</span> <span class="kw">match</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">err</span> {
            <span class="ident">error</span> =&gt; (<span class="kw-2">&amp;</span><span class="ident">error</span>).<span class="ident">anyhow_kind</span>().<span class="ident">new</span>(<span class="ident">error</span>),
        };
        <span class="ident">error</span>
    });
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">fmt</span>:<span class="ident">expr</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>:<span class="ident">tt</span>)<span class="kw-2">*</span>) =&gt; {
        <span class="macro-nonterminal">$</span><span class="macro-nonterminal">crate::Error::msg</span>(<span class="macro-nonterminal">$</span><span class="macro">crate::private::format!</span>(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">fmt</span>, $(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">arg</span>)<span class="kw-2">*</span>))
    };
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="anyhow" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>